# ansivt.pl
# provides more usefull VT100 function codes
# Copyright 2002 Peter Hanely, hanelyp@calweb.com
# Use as you will

package ansivt;

%colors = (''=>0, 'reset'=>0, 'bright'=>1, 'dim'=>2, 'underscore'=>4,
	'blink'=>5, 'reverse'=>7, 'hidden'=>8,
	'red'=>31, 'green'=>32, 'yellow'=>33, 'blue'=>34,
	'magenta'=>35, 'cyan'=>36,
	'black'=>30, 'grey'=>37, 'silver'=>'1;30', 'white'=>'1;37',
	'gold'=>'1;33',
	'bgblack'=>40, 'bgred'=>41, 'bggreen'=>42, 'bgyellow'=>43,
	'bgblue'=>44, 'bgmagenta'=>45, 'bgcyan'=>46, 'bgwhite'=>47);

sub clearcolor
{ "\e[0m"; }

sub color1
{ my ($color) = @_;
  my ($c, @nc);
  my (@colors) = split ';', $color;
  foreach $c (@colors)
  { push @nc, $colors{$c}; }
  $color = "\e[". join (';', @nc). 'm';

#  $color;
}

sub color
{ my ($color) = @_;
  if ($color eq $lastcolor) {return;} # return code only if change
  $lastcolor = $color;
  my ($c, $nc);

  foreach $c (split ';', $color)
  { $nc .= ';' if $nc;
    $nc .= $colors{$c};
  }
  $nc = $nc || '0';
  #$color = 
  "\e[0;". $nc. 'm';
  #$color;
}

sub cls
{ "\e[2J\e[H"; }

sub home
{ my ($x, $y) = @_;
  my $h;
  if (defined $x)
  { $h = "\e[$y;$x".'H'; }
  else
  { $h = "\e[H"; }
  $h;
}

sub clreol
{ "\e[K"; }

sub save_cursor
{ "\e[s"; }

sub unsave_cursor
{ "\e[u"; }
