# hnwizard.pl
# wizard stuff for hacknet
# Copyright 2002 Peter Hanely, hanelyp@calweb.com

#    This file is part of hacknet.

#    hacknet is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.

#    hacknet is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with hacknet; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

# extra / override commands if wizard is set on player
%wizard = ('b'=>\&build, 'm'=>\&monster, 'M'=>\&monsterstat,
	'l'=>\&reload, 'S'=>\&wizsave, 'D'=>\&shutdown,
	'B'=>\&broadcast);

# reload data files without killing players
sub reload
{ my ($wizard) = @_;
  # notify all players of reload
  foreach $player (@players)
  { &notify ($player, "reloading DB from files, hang on"); }
  $wizard->{'mode'} = \&reload2;
}

sub reload2
{ my ($wizard) = @_;
  # mark all 'monsters' as norespawn in case they're held by a player
  foreach $monster (@monsters)
  { $monster->{'norespawn'}++; }

  # clear maps and lists
  undef %players;
  undef %monsters;
  undef @monsters;
  undef %tiles;
  undef @levels;
  undef @levelstat;
  
  # and reload
  &loadall();
  $wizard->{'mode'} = undef;
}

# save stuff
sub wizsave
{ my ($player, $stat, $val);
  my ($pp, $ip);
  # save players
  open PLAYERS, ">players.new";
  foreach $pp (sort (keys %players))
  { $player = $players{$pp};
    print PLAYERS "[OBJECT]\nname=",$player->{'name'},"\n";
    foreach $stat (sort (keys %{$player}))
    { $val = $player->{$stat};
      if (($val) && !(ref $val))
      { print PLAYERS "$stat=$val\n"; }
    }
    print PLAYERS "\%inventory\n";
    foreach $stat (@{$player->{'inventory'}})
    { print PLAYERS $stat->{'species'},'=',($stat->{'count'}+0),"\n";
    }
    print PLAYERS "/\n\n";
  }
  close PLAYERS;
}

sub shutdown
{ $shutdown++; }

# notify all players logged in
sub broadcast
{ my ($player, $cmd) = @_;
  my ($line, $pline);
  select $player->{'socket'};
  tnet::linemode($player->{'socket'});
  print ansivt::home(2,21), ansivt::clreol(), "BB> ";
  $player->{'mode'} = \&broadcast1;
  $player->{'time'} = time();
}
sub broadcast1
{ my ($player, $cmd) = @_;
  my ($line, $pline);
  if ($cmd eq "\e")
  { $player->{'mode'} = undef; }
  elsif (($line = &getstring($player, $cmd)) ne '0')
  { if ($player->{'time'} != time())
    { tnet::charmode($player->{'socket'});
      while ($pline = substr ($line,0,40))
      { foreach $pp (@players)
        { &notify ($pp, ': '.$pline, $player);
          $line = substr($line,50);
	}
      }
      $player->{'mode'} = undef;
      getc ($player->{'socket'}); # clean annoying partner of EOL
    }
  }
}
