# login.pl
# login routines for hacknet
# Copyright 2002 Peter Hanely, hanelyp@calweb.com

#    This file is part of hacknet.

#    hacknet is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.

#    hacknet is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with hacknet; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

sub checkpass
{ my ($player, $pp, $passwd) = @_;
  if ($pp->{'passwd'} eq $passwd)
  { $player->{'mode'} = undef;  # next loop processes as normal
    $pp->{'li'} = 'li';
    &notifyrange($player, $name.' connects');
    print "login: $name\r\n";
    while ($cmd = getc $player->{'socket'}){} # clear stream buffer
    tnet::charmode ($player->{'socket'}, $player);
    # transfer stats from player master record to connection record
    foreach $key (keys %{$pp})
    { $player->{$key} = $pp->{$key}; }
  }
  else
  { &notify ($player, 'gatekeeper: Say again, who be ye?');
    $player->{'mode'} = \&gatekeeper1;
  }
}

# state initial
sub gatekeeper
{ my ($player) = @_;
  tnet::linemode($player->{'socket'});
  &notify ($player, 'gatekeeper: Ahoy! who be ye?');
  $player->{'mode'} = \&gatekeeper1;
  $player->{'level'} = $mapindex{'gatekeeper'};
  $player->{'x'} = 7;  $player->{'y'} = 5;
}

# state wait for a username
sub gatekeeper1
{ my ($player, $cmd) = @_;
  &quit($player, $cmd) if ($cmd eq "\x03");
  if (($line = &getstring($player, $cmd)) ne '0')
  { ($name, $passwd) = split /\s/, $line;
    if ($name eq 'new')
    { &notify ($player, 'gatekeeper: Aye, a new adventurer');
      &notify ($player, 'gatekeeper: Have ye a name?');
      $player->{'mode'} = \&gatekeeper3;
      return;
    }
    if ($name =~ /(bye|quit)/)
    { &quit($player, "\x03"); }
    $pp = $players{$name};
    if (!(ref $pp))
    { &notify ($player, 'gatekeeper: Say again, who be ye?');
      return;
    }
    if (!$passwd)
    { &notify ($player, 'gatekeeper: And how I know it be ye?');
      &notify ($player, '(password)');
      $player->{'mode'} = \&gatekeeper2;
      $player->{'pp'} = $pp;
    }
    else { &checkpass($player, $pp, $passwd); }
  }
}
# state wait for password
sub gatekeeper2
{ my ($player, $cmd) = @_;
  &quit($player, $cmd) if ($cmd eq "\x03");
  if (($line = &getstring($player, $cmd)) ne '0')
  { ($passwd) = split /\s/, $line;
    $pp = $player->{'pp'};
    &checkpass($player, $pp, $passwd);
  }
}
# state 3 get player name, NP
# temp until public new player creation
sub gatekeeper3
{ my ($player, $cmd) = @_;
  my ($prof, $key);
  &quit($player, $cmd) if ($cmd eq "\x03");
  if (!$registernew)
  { &notify ($player, 'gatekeeper: Never mind, be off with you!');
    &quit($player);
  }
  if (($line = &getstring($player, $cmd)) ne '0')
  { ($name) = split /\s/, $line;
    $player->{'name'} = $name;
    &notify ($player, "gatekeeper: Hail $name");
    &notify ($player, 'gatekeeper: what profession might ye be?');
    # list professions
    foreach $prof (sort keys %players)
    { if ($prof =~ /prof/)
      { $prof =~ s/prof//;
        &notify ($player, chr ($key+ord('a'))."> $prof");
	$profs[$key] = $prof;
	$key ++;
      }
    }
    $player->{'mode'} = \&gatekeeper4;
  }
}

# state 4 get player class, NP
sub gatekeeper4
{ my ($player, $cmd) = @_;
  my ($key, $k);
  &quit($player, $cmd) if ($cmd eq "\x03");
  $key = ord(lc $cmd) - ord('a');
  if (($key < 0) || ($key > $profs))
  { &notify ($player, 'gatekeeper: what profession did ye say?');
    # list professions
    foreach $prof (@profs)
    { &notify ($player, chr ($key+ord('a'))."> $prof");
      $key ++;
    }
  }
  else
  { $player->{'class'} = $profs[$key];
#    foreach $k (keys %{$players{'prof'.$profs[$key]}})
#    { $player->{$k} = $players{'prof'.$profs[$key]}->{$k};
#    }
    &notify ($player, 'gatekeeper: and when again we meet,');
    &notify ($player, 'gatekeeper: how I know it be ye?');
    $player->{'mode'} = \&gatekeeper5;
  }
}
# state 5 get password, NP
sub gatekeeper5
{ my ($player, $cmd) = @_;
  &quit($player, $cmd) if ($cmd eq "\x03");
  if (($line = &getstring($player, $cmd)) ne '0')
  { ($passwd) = split /\s/, $line;
    $player->{'passwd'} = $passwd;
    &notify ($player, "gatekeeper: Say again, to be sure we're straight?");
    $player->{'mode'} = \&gatekeeper6;
  }
}
# state 6 repeat password NP
sub gatekeeper6
{ my ($player, $cmd) = @_;
  &quit($player, $cmd) if ($cmd eq "\x03");
  if (($line = &getstring($player, $cmd)) ne '0')
  { ($passwd) = split /\s/, $line;
    if ($player->{'passwd'} ne $passwd)
    { &notify ($player, "gatekeeper: That was different. Say again?");
      $player->{'mode'} = \&gatekeeper5;
    }
    else
    { $player->{'mode'} = undef;
      &notify ($player, "gatekeeper: Aye, I've got it. welcome in");
      foreach $k (keys %{$players{'prof'.$profs[$key]}})
      { $player->{$k} = $players{'prof'.$profs[$key]}->{$k};
      }
      $player->{'mode'} = undef;
    }
  }
}
1;
