# code for merchant AI, hacknet

sub merchant_AI
{ my ($monster, $target, $player) = @_;
  while (($act = pop @{$monster->{'msg'}} ) ne "")
    { $actor = pop @{$monster->{'msgsend'}};
      if (ref $actor)
      { if ($act =~ /(push|buy)/)
        { &merchant_listshop($monster, $actor);
	  $actor->{'merchant'} = $monster; # so code can find way back
	  $actor->{'mode'} = \&merchant_buy;
	  #print "merchant started\n"; 
	  #&breakpoint();
	  #&dumpobj($actor);
	}# if buy signal
      }
    }
}

sub merchant_listshop
{ my ($monster, $target, $player) = @_;
  &notify ($target, ($monster->{'name'}||'merchant').
	": What can I do you for?");
  my ($key);
  foreach $key (sort (keys %{$monster}))
  { if (((length $key) == 1) && (ord ($key) < ord ('p')) )
    { &notify ($target, $key.'> '.($monster->{$key})); }
  }
  &notify ($target, 's> Id rather sell');
  &notify ($target, 'q> nothing for now');
}

sub merchant_buyprice
{ my ($obj) = @_;
  int($monsters{$obj}->{'price'}* 0.6) || 
	$monsters{$obj}->{'AC'} + $monsters{$obj}->{'hit'} +
	$monsters{$obj}->{'lamp'} + 5*$monsters{$obj}->{'vision'};
}

sub merchant_listsell
{ my ($monster, $target, $player) = @_;
  &notify ($target, ($monster->{'name'}||'merchant').": Aye, what have ye to sell me?");
  my ($count, $shown, $obj, $name, %list, @list, $price, %exclude);

  foreach $obj (values %{$target->{'wear'}}) # don't sell 'shirt' off your back
  { $exclude{$obj} = 1;
#  print "buy excluding ", $obj->{'species'}, "\n";
  }

  foreach $obj (@{$target->{'inventory'}})
  { if ($shown < 15)
    { $name = $obj->{'species'};
      if ( (! ref $list{$name}) && (! $exclude{$obj}) )
      { $list{$name} = {'count'=>($obj->{'count'} || 1), 'index'=>chr($count + ord('A'))};
        push @list, $name;
      }
      $shown ++;
    }
    $count++
  }

  $shown = 0;
  foreach $obj (@list)
  { $price = &merchant_buyprice($obj);
    &notify ($target, $list{$obj}->{'index'}.">".$obj." - ".$list{$obj}->{'count'}." at $price")
	if $price;
    $shown ++ if $price; 
  }
  &notify ($target, "nothing of interest to me") if $shown <= 0;
  &notify ($target, "q>nothing now");
}

sub merchant_buy # accept players order, deduct gold
{ my ($monster, $target, $player) = @_;
# ($monster, $target) = ($player, $cmd); 
#&breakpoint();
if (defined ( $item = ($monster->{'merchant'}->{$target})) )
  { if (ref $item) { &{$item}($monster); }
    elsif ($item ne "")
    { ($name, $cost) = split ';', $item;
      if ($cost > $monster->{'gold'})
      { &notify ($monster, ($monster->{'merchant'}->{'name'}||'merchant').
	": Ye have not the gold for ".$name);}
      else
      { $boxitem = {'species'=>$name, 'count'=>$1};
	push @{$monster->{'inventory'}}, $boxitem;
	# copy attributes for this object type
	foreach $key (keys %{$monsters{$name}})
	{ $boxitem->{$key} = $monsters{$name}->{$key} if ($key !~ /^_/); }
	$monster->{'gold'} -= $cost;
	&notify ($monster, ($monster->{'merchant'}->{'name'}||'merchant').": Sold, 1 ".$name);
      }
    }
    else { print "merch error"; }
  }
else { &merchant_listshop($monster->{'merchant'}, $monster); }
#print "buydone";
}

sub merchant_sell
{ my ($monster, $target, $player) = @_;
my ($name, $price, $obj, $offset, $item);

$offset = ord ($target) - ord ('a');
$item = $monster->{'inventory'}->[$offset];
$name = $item->{'species'};
#print "sales command '$target : $offset : $name'\n";

if ($target eq 'q')
{ &merchant_quit($monster); }
elsif (ref $monster->{'selectedsell'})
{ $obj = $monster->{'selectedsell'};
  # get count to sell, exchange item(s) for cash
  if ( ($target >= 1) && ($target <= ($obj->{'count'}) ) )
  { &consume ($monster, $obj, $target);
    $price = $target * &merchant_buyprice($obj->{'species'});
#print "selling for ", &merchant_buyprice($obj->{'species'}), "\n";
    $monster->{'gold'} += $price;
    &notify ($monster, "$price gold for $target ".$obj->{'species'});
  }
  else
  { &notify ($monster, "none.  Anthing else?"); }
  $monster->{'selectedsell'} = undef;
}
elsif ((length($target) == 1) && ($offset < 17) && ($offset >= 0) &&
	(ref $monsters{$name}) &&
	($name ne '') )
{  # have item to sell
  if (&merchant_buyprice($name))
  { $monster->{'selectedsell'} = $item;
    &notify ($monster, "Aye, how many $name do ye wish to sell?");
  }
  else
  { &notify ($monster, "I has no interest in $name"); }
}
else
{ &merchant_listsell($monster->{'merchant'}, $monster);
  $monster->{'mode'} = \&merchant_sell;
  $monster->{'selectedsell'} = undef;
}
}

sub merchant_quit
{ my ($monster, $target, $player) = @_;
# clean exit of merchant machine
&notify ($monster, ($monster->{'merchant'}->{'name'}||'merchant').": Come again");
$monster->{'mode'} = undef;
}

1;
