# refresh notifications
sub redraw_message
{ my ($player) = @_;
  my ($x, $y, $msg, @nmesg, @tmesg, $map);
  my (@msg) = @{$player->{'msg'}};
  # process @msg
  $x = 0;
  while ($msg = pop @msg)
  { push (@nmsg, $msg) if ($msg =~ /\w/) && ($x ++ < 17); }
  
  for ($y = 17; $y > 0; $y--) # $y increases upward, build downward
  { $msg = pop @nmsg;
    #$mapline = pop @screen;
    $mapline = join '', @{$screen->[$y]};
    $map .= ansivt::home(25,20-$y).$msg.ansivt::clreol();
  }
  select $player->{'socket'};
  print ansivt::save_cursor().$map.ansivt::unsave_cursor();
  select STDOUT;
  $player->{'newmessage'} = 0;
}

# redraw, clipping line of sight
sub show_n_shadow
{ my ($x, $y, $nx, $ny, $screen, $shadow, $l) = @_;
  my ($shad, $dx, $dy, $s1);
  return if (($x < 1) || ($y < 1) || ($nx < 0) || ($ny < 0));
  #substr($screen->[$y], $x,1) = '0';
  if ($shadow->[$y]->[$x] < $vision) # this spot visable, plot it
  { $spot = $l->[$ny]->[$nx];
    #substr($screen->[$y], $x,1) = '1';
    if (ref $spot)
    { #substr($screen->[$y], $x,1) = '2';
      if (ref $spot->[1])
      { $tile = $spot->[1]->{'symbol'};
        if ($tile eq "")
        { $mtype = $spot->[1]->{'type'};
	  $tile = $monsters{$mtype}->{'symbol'} || '?';
        }
        $colr = $spot->[1]->{'color'};
        $tile = ansivt::color($colr).$tile.ansivt::color();
	$screen->[$y]->[$x] = $tile;
	$shad = 0;
      }
      else # nothing here
      { $tile = $spot->[0] || ' ';
	$screen->[$y]->[$x] = ansivt::color($tiles{$tile}->{'color'}).$tile.ansivt::color();
	$shad = 1-($tiles{$tile}->{'visable'});
	$shad = 0 if ($tiles{$tile}->{'visable'} eq '');
      }
    }
    # off map
    else {$tile = ' '; $shad = 2;}
  }
  else # invisable
  { $tile = ' ';
    $shad = 2;
    #substr($screen->[$y], $x,1) = '!';
  }
  # set shadows
  $dx = (($x-8)<=>0); $dy = (($y-8)<=>0);
  $s1 = $shadow->[$y]->[$x];
  #$shad += $s1;
  $shadow->[$y+$dy]->[$x+$dx] += 2*$shad;
  $shadow->[$y+$dy]->[$x] += $shad;
  $shadow->[$y]->[$x+$dx] += $shad;
#  $shadow->[$y+$dy]->[$x] += $shad if $dx && ($dx == ($x-8));
#  $shadow->[$y]->[$x+$dx] += $shad if $dy && ($dy == ($y-8));
  if ($dy == 0)
  { $shadow->[$y+1]->[$x+$dx] += $shad;
    $shadow->[$y-1]->[$x+$dx] += $shad;
  }
  if ($dx == 0)
  { $shadow->[$y+$dy]->[$x+1] += $shad;
    $shadow->[$y+$dy]->[$x-1] += $shad;
  }

#  $screen->[$y+$dy]->[$x+$dx] = $shadow->[$y+$dy]->[$x+$dx];
#  $screen->[$y+$dy]->[$x] = $shadow->[$y+$dy]->[$x];
#  $screen->[$y]->[$x+$dx] = $shadow->[$y]->[$x+$dx];
}

sub clip_redraw
{ my ($player) = @_;
  my ($px, $py, $level) = ($player->{'x'}, $player->{'y'}, $player->{'level'} );
  my ($r, $x, $y, $mapline, $map, $screen, $shadow, $tile, $spot, @map);
  my ($nx, $ny, $l, $ly);
  my (@msg) = @{$player->{'msg'}};
  my ($msg, @tmsg);
  my ($light); local($vision);

  $level = $level || 0;

  $light = 7 + $player->{'lamp'} - $levelstat[$level]->{'darkness'};
  $light = 7 if $light > 7;
  $light = 1 if $light < 1;
  
  $vision = 2 + $player->{'vision'};
  
  if ($player->{'wizard'}) {$light = 7; $vision=21;}
  
  # process @msg
  $x = 0;
  while ($msg = pop @msg)
  { push (@nmsg, $msg) if ($msg =~ /\w/) && ($x ++ < 17); }
  
  select $player->{'socket'};
#print "\@($px, $py, $level)\r\n";
  # map changes
  $l = $levels[$level];
  
  # initialize blank map
  for ($y = 0; $y <=17; $y ++)
  { #$screen[$y] = '                 ';#'#################'; #
    for ($x = 0; $x <=17; $x ++)
    { $screen->[$y]->[$x] = ' '; #chr ($x%10 + ord('0')); #' ';
      $shadow->[$y]->[$x] = 0;
    }
  }
  $screen->[8]->[8] = ansivt::color($player->{'color'}).'@'.ansivt::clearcolor();
  for ($r = 1; $r <= $light; $r++)
  { for ($x = -$r; $x <= $r; $x++)
    { &show_n_shadow ($x+8, $r+8, $x + $px, $py + $r, $screen, $shadow, $l);
      &show_n_shadow ($x+8, -$r+8, $x + $px, $py - $r, $screen, $shadow, $l);
    }
    for ($x = -$r+1; $x < $r; $x++)
    { &show_n_shadow ($r+8, $x+8, $px + $r, $py + $x, $screen, $shadow, $l);
      &show_n_shadow (-$r+8, $x+8, $px - $r, $py + $x, $screen, $shadow, $l);
    }
  }
  for ($y = 17; $y > 0; $y--) # $y increases upward, build downward
  { $msg = pop @nmsg;
    #$mapline = pop @screen;
    $mapline = join '', @{$screen->[$y]};
    push @map, "      ".$mapline.ansivt::color(); #"   ".$msg.ansivt::clreol();
  }
  $map = ansivt::home();
  $map .= "\@($px, $py, ".$maprevindx{$level}.")".
	"  health=".int($player->{'health'}*1-$player->{'dammage'}).'/'.($player->{'health'}*1).
	"  gold=".($player->{'gold'}*1).
#	"  AC=".$player->{'wear'}->{'armor'}->{'species'}.':'.int($player->{'AC'}*1).
#	"  Hit=".$player->{'wear'}->{'weapon'}->{'species'}.':'.int(($player->{'hit'}*1)||10).
	"  AC=".int($player->{'AC'}*1)."  Hit=".int(($player->{'hit'}*1)||10).
	"  Exp=".int($player->{'experience'}).
	ansivt::clreol()."\r\n".ansivt::clreol().
	ansivt::home(1,3). join "\r\n", @map;
  $map .= "\r\n".ansivt::clreol().$player->{'effects'}; #.ansivt::home(0,20);
  print ansivt::save_cursor().$map.ansivt::unsave_cursor();
  #print $map;

  select STDOUT;
  $player->{'redraw'} = 0;
  $player->{'effects'} = '';
}

# simple non clipping redraw
# +/- 8 of player
sub redraw
{ my ($player) = @_;
  my ($px, $py, $level) = ($player->{'x'}, $player->{'y'}, $player->{'level'} );
  my ($x, $y, $mapline, $map, $tile, $spot, @map);
  my ($nx, $ny, $l, $ly);
  my (@msg) = @{$player->{'msg'}};
  my ($msg, @tmsg);
  $level = $level || 0;

  # process @msg
  $x = 0;
  while ($msg = pop @msg)
  { push (@nmsg, $msg) if ($msg =~ /\w/) && ($x ++ < 17); }
  
  select $player->{'socket'};
#print "\@($px, $py, $level)\r\n";
  # map changes
  $l = $levels[$level];
  for ($y = 8; $y >= -8; $y--) # $y increases upward, build downward
  { $ny = $py+$y;
    $mapline = "";
    $ly = $l->[$ny];
    for ($x = -8; $x <= 8; $x++)
    { undef $spot;
      $tile = '?';
      $nx = $px+$x;  
      if (($nx >=0) && ($ny >= 0))
      { eval # $spot = $levels[$level]->[$ny]->[$nx];
	{ # arrays act strangely when index < 0
	  $spot = $ly->[$nx];
	};
	if (defined $spot)
	{ if (defined $spot->[1])
	  { $tile = $spot->[1]->{'symbol'};
	    if ($tile eq "")
	    { $mtype = $spot->[1]->{'type'};
	      $tile = $monsters{$mtype}->{'symbol'} || '?';
	    }
	    #if
	    ($colr = $spot->[1]->{'color'});
	    { $tile = ansivt::color($colr).$tile.ansivt::color(); }
	    #elsif ($colr = $monsters{$mtype}->{'color'})
	    #{ $tile = $colors{$colr}.$tile.$colors{''}; }
	  }
	  else
	  { $tile = $spot->[0]; }
	}
	else {$tile = ' '; }
      }
      else { $tile = ' '; } # off edge in - direction
      #if (defined $tiles{$tile}->{'color'})
      { $mapline .= ansivt::color($tiles{$tile}->{'color'}); } #.$tile.ansivt::color(); }
      $mapline .= $tile;
    }
    # events and chat
    #$msg = "";
    #while (($msg !~ /\w/) && (@msg)) { $msg = pop @msg; }
    $msg = pop @nmsg;
    push @map, "      ".$mapline.ansivt::color()."   ".$msg.ansivt::clreol();
  }
  $map = ansivt::home();
  $map .= "\@($px, $py, $level)  health=".($player->{'health'}*1).'-'.
	int($player->{'dammage'}). "  gold=".($player->{'gold'}*1).
	"  AC=".$player->{'wear'}->{'armor'}->{'species'}.':'.($player->{'AC'}*1).
	"  Hit=".$player->{'wear'}->{'weapon'}->{'species'}.':'.(($player->{'hit'}*1)||10).
	ansivt::clreol(). "\r\n".ansivt::clreol().
	ansivt::home(1,3). join "\r\n", @map;
  $map .= "\r\n".ansivt::clreol().$player->{'effects'}; #.ansivt::home(0,20);
  print ansivt::save_cursor().$map.ansivt::unsave_cursor();
  #print $map;

  select STDOUT;
  $player->{'redraw'} = 0;
  $player->{'effects'} = '';
}


1;
