# tnet.pl
# a few usefull telnet tidbits
# Copyright 2002 Peter Hanely, hanelyp@calweb.com
# use as you will

package tnet;

# =====================
# terminal mode stuff
# =====================
#$dump = 1;

$int = "\x03";
$IAC = "\xff"; # 255
$DO = "\xfd"; # 253
$WILL = "\xfb"; # 251
$WONT = "\xfc"; # 252
$DONT = "\xfe"; # 254
$SB = "\xfa"; # sub negotiation, 250
$IP = "\xf4"; # 244, interrupt process
$SE = "\xf0"; # end sub negotiation 240

$ECHO = "\x01"; # rfc 857
$SGA = "\x03"; # SUPPRESS-GO-AHEAD rfc 858
$RCTE ="\x07";
$set_TX_char = "\x11";
$TC1 = "\x01";
$TC2 = "\x57";

$TERMINALTYPE = "\x18";
$SEND = "\x01";
$IS = "\x00";

$names = ($DO=>'DO', $WILL=>'WILL', $DONT=>'DONT', $WONT=>'WONT', $IP=>'INTERRUPT', $IAC=>'IAC',
	$ECHO=>'ECHO', $SGA=>'SGA');

$do_query_terminal = "$IAC$DO$TERMINALTYPE".
	"$IAC$SB$TERMINALTYPE$SEND$IAC$SE";
	
# process whatever telnet client tries to send
# assume whole command in one packet, so no blocking
# rather brain dead right now.
# parameters:
# $socket	ref to filehandle
# $player	hashref containing SB replies/results
sub telnet
{ # return; # this isn't doing anything productive
  my ($socket, $player) = @_;
  my ($command, $opt, $reply);
  $command = getc($socket);
  $opt = getc($socket);
  print STDOUT "telnet..." if $dump;
  
  if ($names{$command})
  { $player->{$names{$opt}} = $names{$command}; }
  select $socket;
  if ($command eq '')
  { print STDOUT "AIC null\n" if $dump; }
  elsif ($command eq $DO)
  { print STDOUT "DO ",ord ($opt), "\n" if $dump;
  }
  elsif ($command eq $WILL)
  { print STDOUT "WILL ",ord ($opt), "\n" if $dump;
  }
  elsif ($command eq $SB)
  { # print it, human readable
    { $reply = "IAC DO ",ord($opt);
      while ($opt=getc($player->{'socket'}) ne $tnSE)
      { if ($opt =~ /[\s\w]/) { $reply .= $opt; }
        else { $reply .= ord($opt).' '; }
      }
    }
  }
  elsif ($command eq $WONT)
  { print $IAC,$DONT,$opt;
    print STDOUT "dont ", ord ($opt), "\n" if $dump;
  }
  elsif ($command eq $DONT)
  { print $IAC,$WONT,$opt;
    print STDOUT "wont ", ord ($opt), "\n" if $dump;
  }
  elsif ($command eq $IP)
  { main::quit($player, '!!!'); }
  else # get a read on whatever the client is trying
  { print STDOUT "IAC ", ord($command), " ", ord($opt), "\n" if $dump;
  }
}
# set telnet terminal to send on most any character
sub charmode
{ my ($terminal) = @_;
  select $terminal;
  # do it dumb, ignore any replys
  print $int,$IAC,$WILL,$SGA,$IAC,$WILL,$ECHO;
}

sub linemode
{ my ($terminal) = @_;
  select $terminal;
  # do it dumb, ignore any replys
  print $int,$IAC,$WONT,$SGA,$IAC,$WONT,$ECHO;
}
sub echo_on
{ my ($terminal) = @_;
  select $terminal;
  print $IAC,$WILL,$ECHO;
}
# query terminal type
sub gettermtype
{ my ($terminal, $player) = @_;
  my ($tty, $type);
  select $terminal;
  print $do_query_terminal;
  # read reply and parse
  $player->{'mode'} = \&gettermtype2;
}

sub gettermtype2
{ my ($player, $cmd) = @_;
  my ($sock) = $player->{'socket'};
  $/ = $tnSE;
  $player->{'tty'} .= $cmd;
  $player->{'tty'} .= <$sock>;
  if ($player->{'tty'} =~ /$SE/)
  { # parse reply
    $player->{'tty'} =~ /$IAC$SB$TERMINALTYPE$IS([\w\s]+)$IAC$SE/;
    $type = $1;
    if ($type =~ /\w/)
    { $player->{'tty'} = $type;
      $player->{'mode'} = undef;
      # setup curses this termonal
    }
    else
    { $player->{'tty'} =~ s/.*$SE//; }
  }
}

1;
