# watch a variable, dump call stack whenever somebody reads or writes
package watchscaler;

sub TIESCALAR
{ my ($pkg, $name) = @_;
  my (%scaler);
  $scaler{'name'} = $name;
  return (bless \%scaler, $pkg);
}

sub FETCH
{ my ($r_scal) = @_;
  my ($key, $package, $filename, $line);
  print STDERR "FETCH ",$r_scal->{'name'},"\n";
  for ($key = 2; $key >= 0; $key--)
  { ($package, $filename, $line) = caller ($key);
    print STDERR "$package:$filename:$line\n";
  }
  return ($r_scal->{'val'});
}

sub STORE
{ my ($r_scal, $val) = @_;
  my ($key, $package, $filename, $line);
  print STDERR "STORE ",$r_scal->{'name'},"=$val\n";
  for ($key = 2; $key >= 0; $key--)
  { ($package, $filename, $line) = caller ($key);
    print STDERR "$package:$filename:$line\n";
  }
  return ($r_scal->{'val'} = $val);
}

1;
